<?php

  /*

    Copyright (C) 2013 Artem Prilutskiy, R3ABM (r3abm@dstar.su)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

  */

  include("ServiceResponse.php");

  define("GATEWAY_CONFIG", "/etc/ircddbgateway");
  define("R3ABM_CONFIG", "/home/opendv/node.conf");
  define("DL5DI_CONFIG", "/home/opendv/repeater/repeater_conf");

  if (preg_match('/^WIN/', PHP_OS) ||
      !file_exists(GATEWAY_CONFIG))
    exit();

  $output = array();

  $repeaters = array(
    1 => array(),
    2 => array(),
    3 => array(),
    4 => array()
  );

  $modes = array(
    "duplex",
    "simplex",
    "gateway",
    "tx",
    "rx",
    "txrx"
  );

  if (file_exists(DL5DI_CONFIG))
  {
    $content = file_get_contents(DL5DI_CONFIG);
    foreach (explode("\n", $content) as $line)
      if (preg_match('/^REPEATERCONFIG_(\d)=([\w\/]*)$/', $line, $matches))
        $repeaters[$matches[1]]["file"] = $matches[2];
  }

  if (file_exists(R3ABM_CONFIG))
  {
    $content = file_get_contents(R3ABM_CONFIG);
    foreach (explode("\n", $content) as $line)
    {
      if (preg_match('/^REPEATER=(\w*)$/', $line, $matches))
        $repeaters[1]["file"] = dirname(DL5DI_CONFIG) . "/" . $matches[1] . "_1";
      if (preg_match('/^REPEATER[(\d)]=(\w*)$/', $line, $matches))
        $repeaters[$matches[1]]["file"] = dirname(DL5DI_CONFIG) . "/" .$matches[2] . "_" . $matches[1];
    }
  }

  $content = file_get_contents(GATEWAY_CONFIG);
  foreach (explode("\n", $content) as $line)
  if (preg_match('/^repeater(\w+)(\d)=(\w*)$/', $line, $matches))
    $repeaters[$matches[2]][$matches[1]] = $matches[3];

  foreach ($repeaters as $number => $repeater)
    if (array_key_exists("Band", $repeater))
    {
      $data = array(
        "type" => "ICOM",
        "mode" => "duplex"
      );
      if ($repeater["Type"] == 0)
      {
        $data["type"] = preg_replace(array('/^.+\//', '/_\d$/'), "", $repeater["file"]);
        $content = file_get_contents($repeater["file"]);
        foreach (explode("\n", $content) as $line)
        {
          if (preg_match('/^mode=([1-5])$/', $line, $matches))
            $data["mode"] = $modes[$matches[1]];
        }
      }
      $output[$repeater["Band"]] = $data;
    }

  send($output);

?>