<?php

  include("RemoteControl.php");
  include("Configuration.php");
  include("LocalGateway.php");

  if (defined("REMOTE_LIST") &&
      array_key_exists("REMOTE_ADDR", $_SERVER) &&
      in_array($_SERVER["REMOTE_ADDR"], explode(",", REMOTE_LIST)) &&
      array_key_exists("module", $_GET) &&
      array_key_exists("reflector", $_GET) &&
      preg_match('/^[A-E]$/', $_GET["module"]) &&
      preg_match('/^(REF\d{3}\s[A-D]|XRF\d{3}\s[A-E]|DCS\d{3}\s[A-Z]|)$/', $_GET["reflector"]))
  {
    $reflector = $_GET["reflector"];
    $remote = new RemoteControl(GATEWAY_HOST, GATEWAY_PORT);

    if ($remote->logIn(GATEWAY_PASSWORD) !== TRUE)
      exit();

    foreach ($remote->queryCalls() as $module)
    {
      if (($module["type"] == "R") &&
          (substr($module["call"], 7, 1) == $_GET["module"]))
      {
        $call = $module["call"];
        $parameters = $remote->queryRepeater($call);
        foreach ($parameters["links"] as $link => $parameters)
          if (($link != $reflector) &&
              ($parameters["direction"] == "Out") &&
              ($parameters["protocol"] != "CCS") &&
              ($parameters["linked"] == TRUE))
            $remote->unlinkRepeater($call, $parameters["protocol"], $link);
      }
    }

    if (!empty($reflector))
      $remote->linkRepeater($call, RECONNECT_INTERVAL, $reflector);

    $remote->logOut();
  }

?>